#! /bin/bash
SERVER=$1
PORT=$2
PROTOCOL=$3
CNAME=$4
CID=$5
echo $SERVER 
echo $PORT 
echo $CID 
mkdir -p /var/log/n-central
mkdir -p /home/nagent
export LD_LIBRARY_PATH=./:$LD_LIBRARY_PATH 
./InitialValidate  -s $SERVER -n $PORT -p $PROTOCOL -f /home/nagent/nagent.conf -l /var/log/n-central/install_nagent.log -i $CID -c "$CNAME"
retCode=$?
if [ $retCode -ne 0 ]; then 
	case $retCode in
		1) echo "ERROR: Missing server information: $SERVER:$PORT, $PROTOCOL" >> /tmp/a.a
			;;
		2) echo "ERROR: Duplicate server information: $SERVER:$PORT, $PROTOCOL" >> /tmp/a.a
			;;
		3) echo "ERROR: Missing configuration file location: $optString" >> /tmp/a.a
			;;
		4) echo "ERROR: Duplicate configuration file $CONFIG_FILE"; >> /tmp/a.a
			;;
		5) echo "ERROR: Missing identification: name($CNAME), ID($CID), appliance($APPLIANCE)" >> /tmp/a.a
			;;
		6) echo "ERROR: InitialValidate with more than one identity type" >> /tmp/a.a
			;;
		7) echo "ERROR: Missing install log file location" >> /tmp/a.a
			;;
		8) echo "ERROR: Duplicate log file location" >> /tmp/a.a
			;;
		9) echo "ERROR: Unrecognized options in input" >> /tmp/a.a
			;;
		10) echo "ERROR: Cannot connect to n-central server $SERVER:$PORT, $PROTOCOL, $optString" >> /tmp/a.a
			;;
		11) echo "ERROR: Invalid customer name $CNAME" >> /tmp/a.a
			;;
		12) echo "ERROR: Invalid customer ID $CID" >> /tmp/a.a
			;;
		13) echo "ERROR: Invalid appliance ID $APPLIANCE" >> /tmp/a.a
			;;
		14) echo "ERROR: Unable to scan local system's assets" >> /tmp/a.a
			;;
		15) echo "ERROR: Unable to register this appliance $APPLIANCE with server $SERVER:$PORT, $PROTOCOL.\nContact system administrator for more information." >> /tmp/a.a
			;;
		16) echo "ERROR: Unable to access configuration file $CONFIG_FILE" >> /tmp/a.a
			;;
		17) echo "ERROR: Unable to access log file" >> /tmp/a.a
			;;
		*) echo "ERROR: DMS validation failed! ($retCode)" >> /tmp/a.a
	esac
	exit 1
fi
echo "dprg" 
dpkg -i nagent.deb
if [ -f /bin/systemctl ]; then
	echo "Switch to systemd" 
	echo -e '[Unit]\nDescription=N-able Agent\nAfter=cron.service network-manager.service\n[Service]\nEnvironment="LD_LIBRARY_PATH=/opt/nable/usr/lib/"\nExecStart=/usr/sbin/nagent -f /home/nagent/nagent.conf\nExecStartPost=/bin/bash -c "echo `pidof -s nagent` > /var/run/nagent.pid"\nExecStop=rm -f /var/run/nagent.pid\nPIDFile=/var/run/nagent.pid\nRestart=always\n\nKillMode=process\n[Install]\nWantedBy=multi-user.target' > /lib/systemd/system/nagent.service
	ln -sf /lib/systemd/system/nagent.service /etc/systemd/system/multi-user.target.wants/nagent.service
	# remove init.d nagent script 
	rm -f /etc/init.d/nagent 
	# start nagent 
	systemctl daemon-reload
	systemctl stop nagent
	echo "enable nagent"
	systemctl enable nagent
	echo "start nagent" 
	systemctl --no-block start nagent
else
	echo "Switch to init.d" 
	service nagent start
fi
sleep 1
NAGENTPID=`pidof nagent`
if [ ! -z $NAGENTPID ]; then
	echo "nagent started. PID=$NAGENTPID" 
	sleep 5
	exit 0
fi
sleep 5
exit 2
